// Code generated by client-gen. DO NOT EDIT.

package v1alpha1

import (
	"time"

	v1alpha1 "github.com/kyma-project/kyma/components/connectivity-certs-controller/pkg/apis/applicationconnector/v1alpha1"
	scheme "github.com/kyma-project/kyma/components/connectivity-certs-controller/pkg/client/clientset/versioned/scheme"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	rest "k8s.io/client-go/rest"
)

// CentralConnectionsGetter has a method to return a CentralConnectionInterface.
// A group's client should implement this interface.
type CentralConnectionsGetter interface {
	CentralConnections() CentralConnectionInterface
}

// CentralConnectionInterface has methods to work with CentralConnection resources.
type CentralConnectionInterface interface {
	Create(*v1alpha1.CentralConnection) (*v1alpha1.CentralConnection, error)
	Update(*v1alpha1.CentralConnection) (*v1alpha1.CentralConnection, error)
	UpdateStatus(*v1alpha1.CentralConnection) (*v1alpha1.CentralConnection, error)
	Delete(name string, options *v1.DeleteOptions) error
	DeleteCollection(options *v1.DeleteOptions, listOptions v1.ListOptions) error
	Get(name string, options v1.GetOptions) (*v1alpha1.CentralConnection, error)
	List(opts v1.ListOptions) (*v1alpha1.CentralConnectionList, error)
	Watch(opts v1.ListOptions) (watch.Interface, error)
	Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *v1alpha1.CentralConnection, err error)
	CentralConnectionExpansion
}

// centralConnections implements CentralConnectionInterface
type centralConnections struct {
	client rest.Interface
}

// newCentralConnections returns a CentralConnections
func newCentralConnections(c *ApplicationconnectorV1alpha1Client) *centralConnections {
	return &centralConnections{
		client: c.RESTClient(),
	}
}

// Get takes name of the centralConnection, and returns the corresponding centralConnection object, and an error if there is any.
func (c *centralConnections) Get(name string, options v1.GetOptions) (result *v1alpha1.CentralConnection, err error) {
	result = &v1alpha1.CentralConnection{}
	err = c.client.Get().
		Resource("centralconnections").
		Name(name).
		VersionedParams(&options, scheme.ParameterCodec).
		Do().
		Into(result)
	return
}

// List takes label and field selectors, and returns the list of CentralConnections that match those selectors.
func (c *centralConnections) List(opts v1.ListOptions) (result *v1alpha1.CentralConnectionList, err error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	result = &v1alpha1.CentralConnectionList{}
	err = c.client.Get().
		Resource("centralconnections").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Do().
		Into(result)
	return
}

// Watch returns a watch.Interface that watches the requested centralConnections.
func (c *centralConnections) Watch(opts v1.ListOptions) (watch.Interface, error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	opts.Watch = true
	return c.client.Get().
		Resource("centralconnections").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Watch()
}

// Create takes the representation of a centralConnection and creates it.  Returns the server's representation of the centralConnection, and an error, if there is any.
func (c *centralConnections) Create(centralConnection *v1alpha1.CentralConnection) (result *v1alpha1.CentralConnection, err error) {
	result = &v1alpha1.CentralConnection{}
	err = c.client.Post().
		Resource("centralconnections").
		Body(centralConnection).
		Do().
		Into(result)
	return
}

// Update takes the representation of a centralConnection and updates it. Returns the server's representation of the centralConnection, and an error, if there is any.
func (c *centralConnections) Update(centralConnection *v1alpha1.CentralConnection) (result *v1alpha1.CentralConnection, err error) {
	result = &v1alpha1.CentralConnection{}
	err = c.client.Put().
		Resource("centralconnections").
		Name(centralConnection.Name).
		Body(centralConnection).
		Do().
		Into(result)
	return
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().

func (c *centralConnections) UpdateStatus(centralConnection *v1alpha1.CentralConnection) (result *v1alpha1.CentralConnection, err error) {
	result = &v1alpha1.CentralConnection{}
	err = c.client.Put().
		Resource("centralconnections").
		Name(centralConnection.Name).
		SubResource("status").
		Body(centralConnection).
		Do().
		Into(result)
	return
}

// Delete takes name of the centralConnection and deletes it. Returns an error if one occurs.
func (c *centralConnections) Delete(name string, options *v1.DeleteOptions) error {
	return c.client.Delete().
		Resource("centralconnections").
		Name(name).
		Body(options).
		Do().
		Error()
}

// DeleteCollection deletes a collection of objects.
func (c *centralConnections) DeleteCollection(options *v1.DeleteOptions, listOptions v1.ListOptions) error {
	var timeout time.Duration
	if listOptions.TimeoutSeconds != nil {
		timeout = time.Duration(*listOptions.TimeoutSeconds) * time.Second
	}
	return c.client.Delete().
		Resource("centralconnections").
		VersionedParams(&listOptions, scheme.ParameterCodec).
		Timeout(timeout).
		Body(options).
		Do().
		Error()
}

// Patch applies the patch and returns the patched centralConnection.
func (c *centralConnections) Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *v1alpha1.CentralConnection, err error) {
	result = &v1alpha1.CentralConnection{}
	err = c.client.Patch(pt).
		Resource("centralconnections").
		SubResource(subresources...).
		Name(name).
		Body(data).
		Do().
		Into(result)
	return
}
