---
title: How to start
type: Overview
---

Minikube allows you to run Kyma locally, develop, and test your solutions on a small scale before you push them to a cluster. With the Installation and Getting Started guides at hand, you can start developing in a matter of minutes.

Read, learn, and try on your own to:

- [Install Kyma locally](#installation-install-kyma-locally)
- [Install Kyma on a cluster](#installation-install-kyma-on-a-cluster)
- [Deploy a sample service locally](#tutorials-sample-service-deployment-on-local)
- [Deploy a service on a cluster](#tutorials-sample-service-deployment-on-a-cluster)
- [Develop a service locally without using Docker](#tutorials-develop-a-service-locally-without-using-docker)
- [Publish a service Docker image and deploy it to Kyma](#tutorials-publish-a-service-docker-image-and-deploy-it-to-kyma)
- [Configure the Kyma Installer with override values for Helm charts](#configuration-helm-overrides-for-kyma-installation)
- [Register a Broker in Service Catalog](/components/service-catalog#tutorials-register-a-broker-in-the-service-catalog)
- [Create a new Application](/components/application-connector#tutorials-create-a-new-application)
- [Get the client certificate](/components/application-connector#tutorials-get-the-client-certificate)
- [Register a service](/components/application-connector#tutorials-register-a-service)
- [Bind an Application to a Namespace](/components/application-connector#tutorials-bind-an-application-to-a-namespace)
- [Create a Function](/components/serverless/#tutorials-create-a-function)
- [Expose a Function with an API Rule](/components/serverless/#tutorials-expose-a-function-with-an-api-rule)
- [Bind a Service Instance to a Function](/components/serverless/#tutorials-bind-a-service-instance-to-a-function)
- [Trigger a Function with events](/components/serverless/#tutorials-trigger-a-function-with-an-event)
- [Call a registered external service from Kyma](/components/application-connector#tutorials-call-a-registered-external-service-from-kyma)
- [Expose custom metrics in Kyma](/components/monitoring#tutorials-observe-application-metrics)
- [Create a Grafana dashboard](/components/monitoring#tutorials-create-a-grafana-dashboard)
- [Define alerting rules](/components/monitoring#tutorials-define-alerting-rules)
